카카오 도서 API 호출 시 오류

카카오 도서 API 호출 관련해서 오류가 납니다.

PKIX path build failed: java.security.cery.CertPathBuilderException: unable to find valid certification path to requested target

관련해서 DigiCert Global Root G2.crt 인증서도 java cacerts에 추가했는데도 동작하지 않네요 (자바 버전 1.6)

안녕하세요

Java 1.6 에서 TLS 1.2 이상은 기본 지원되지 않습니다.

죄송합니다. 잘못 답변 드렸네요
dapi 의 경우 TLS 1.0부터 지원되고 있습니다.

인증서 설치에 원인이 있을것 같은데요.
다른 원인이 있지 않은지 동일한 환경을 구성하여 확인해 보도록 하겠습니다.

안녕하세요. Java 1.6으로 구현해 보았지만 PKIX 오류가 재현되지 않았습니다.

죄송합니다 1.6이 아닌 다른 버전으로 테스트가 됐었네요ㅜㅜ

인증서를 추가하셨다면 서비스를 재기동하셔야 하는데요 어떤 방식으로 테스트가 되셨을까요?

keytool -importcert -trustcacerts -keystore “C:\Program Files\Java\jdk1.6.0_45\jre\lib\security\cacerts” -alias kdh2 -file “DigiCertGlobalCAG2.crt”

---------------------------------- 이하 cacerts 파일 중 (kdh, kdh2: 추가한것)
키 저장소 비밀번호 입력:
키 저장소 유형: jks
키 저장소 제공자: SUN

키 저장소에 78개의 항목이 포함되어 있습니다.

kdh2, 2022. 9. 14, trustedCertEntry,
인증서 지문(SHA1): D6:AE:E3:16:31:F7:ab:C5:6B:9D:E8:ab:EC:CC:41:08:A6:26:B1:04
kdh, 2022. 9. 14, trustedCertEntry,
인증서 지문(SHA1): DF:3C:24:F9:BF:D6:66:76:1B:26:80:73:FE:06:D1:CC:8D:4F:82:A4

https://dapi.kakao.com/v3/search/book 호출 시
image

https://test-kapi.kakao.com/test-ca-certificates 호출 시
image

좋아요 1

자세한 내용 감사드립니다.
Java 1.6 에서의 요청에서만 위와 같은 문제가 발생하는데요
1.6 대응에 대해 내부 논의 후 답변 드리겠습니다.

감사합니다.

@yeriel4415 조치되었습니다 확인 부탁드립니다.

감사합니다. 정상 통신 됩니다.

죄송합니다.
조치된 내용이 여러 서버에 점진적으로 패치 되다보니 간헐적으로 오류가 있었던것 같습니다.
현재는 모든 서버에 패치되어 정상 동작 합니다.


다른이야기지만, Java6 에서는 SNI를 지원하지 않아 이번과 같은 문제가 발생 하였는데요.
현재 카카오에서 정식 지원하는 Java 버전은 1.8.0_101 이상입니다. (관련공지)

Java 버전을 변경할 수 없는 환경이 많아 이번처럼 지원 되기는 하였지만, 서비스측 환경이 허락하신다면 Java버전을 올리는 것을 권장 드립니다.